﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using XamTreeProblem.Annotations;

namespace XamTreeProblem
{
    public class Cluster
    {
        public Cluster()
        {
            Activities = new ObservableCollection<Activity>();
        }

        private string _name;
        private ObservableCollection<Activity> _activities;

        public string Name
        {
            get { return _name; }
            set { _name = value; OnPropertyChanged("Name"); }
        }

        public ObservableCollection<Activity> Activities
        {
            get { return _activities; }
            set { _activities = value; OnPropertyChanged("Activities"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
