﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;
using Infragistics.Windows.DataPresenter;

namespace XamTreeProblem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private XamTreeGrid _clickedTree;
        private Cluster _currentCluster;
        private Activity _currentActivity;
        private Task _currentTask;
        private object _currentMethodtaskmapping;

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new VM();
        }

        private void XamMenuItemExpandAll_OnClick(object sender, EventArgs e)
        {
            if (_clickedTree != null)
            {
                _clickedTree.Records.ExpandAll(true);
                _clickedTree.UpdateLayout();
            }
        }

        private void XamMenuItemCollapseAll_OnClick(object sender, EventArgs e)
        {
            if (_clickedTree != null)
            {
                _clickedTree.Records.CollapseAll(true);
                _clickedTree.UpdateLayout();
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void XamContextMenuClusters_Opening(object sender, OpeningEventArgs e)
        {
            _currentCluster = null;
            _currentActivity = null;
            _currentTask = null;
            _currentMethodtaskmapping = null;
            var elements = e.GetClickedElements<DataRecordPresenter>();
            if (elements.Count > 0)
            {
                var datarecordbase = elements[0];
                datarecordbase.IsSelected = true;

                if (datarecordbase.DataRecord != null && !datarecordbase.IsHeaderRecord)
                {
                    var item = datarecordbase.DataRecord;

                    _clickedTree = datarecordbase.DataPresenter as XamTreeGrid;
                    if (item.DataItem is Cluster)
                    {
                        _currentCluster = item.DataItem as Cluster;
                       // if (datarecordbase.DataRecord.ParentRecord != null && datarecordbase.DataRecord.ParentDataRecord != null)
                         //   _currentParentItem = datarecordbase.DataRecord.ParentDataRecord.DataItem as ViewModelBase;

                        // cluster menu items
                        ((XamMenuItem)contextMenuClusters.Items[0]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[1]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[2]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[3]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[4]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[5]).Visibility = Visibility.Visible;

                        // activity menu items
                        ((XamMenuItem)contextMenuClusters.Items[6]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[7]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[8]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[9]).Visibility = Visibility.Collapsed;

                        // task menu items
                        ((XamMenuItem)contextMenuClusters.Items[10]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[11]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[12]).Visibility = Visibility.Collapsed;
                    }
                    else if (item.DataItem is Activity)
                    {
                        _currentActivity = item.DataItem as Activity;
                        //if (datarecordbase.DataRecord.ParentRecord != null && datarecordbase.DataRecord.ParentDataRecord != null)
                        //{
                          //  if (datarecordbase.DataRecord.ParentDataRecord.DataItem is Cluster)
                               // _currentParentItem = (ClusterViewModel)datarecordbase.DataRecord.ParentDataRecord.DataItem;
                        //}

                        // cluster menu items
                        ((XamMenuItem)contextMenuClusters.Items[0]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[1]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[2]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[3]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[4]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[5]).Visibility = Visibility.Collapsed;

                        // activity menu items
                        ((XamMenuItem)contextMenuClusters.Items[6]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[7]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[8]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[9]).Visibility = Visibility.Visible;

                        // task menu items
                        ((XamMenuItem)contextMenuClusters.Items[10]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[11]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[12]).Visibility = Visibility.Collapsed;
                    }
                    else if (item.DataItem is Task)
                    {
                        _currentTask = item.DataItem as Task;
                        //if (datarecordbase.DataRecord.ParentRecord != null && datarecordbase.DataRecord.ParentDataRecord != null)
                        //{
                          //  if (datarecordbase.DataRecord.ParentDataRecord.DataItem is Activity)
                                //_currentParentItem = (ActivityViewModel)datarecordbase.DataRecord.ParentDataRecord.DataItem;
                        //}

                        // cluster menu items
                        ((XamMenuItem)contextMenuClusters.Items[0]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[1]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[2]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[3]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[4]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[5]).Visibility = Visibility.Collapsed;

                        // activity menu items
                        ((XamMenuItem)contextMenuClusters.Items[6]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[7]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[8]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[9]).Visibility = Visibility.Collapsed;

                        // task menu items
                        ((XamMenuItem)contextMenuClusters.Items[10]).Visibility = Visibility.Collapsed;
                        ((XamMenuItem)contextMenuClusters.Items[11]).Visibility = Visibility.Visible;
                        ((XamMenuItem)contextMenuClusters.Items[12]).Visibility = Visibility.Visible;
                    }
                }
                else
                {
                    ((XamMenuItem)contextMenuClusters.Items[0]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[1]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[2]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[3]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[4]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[5]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[6]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[7]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[8]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[9]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[10]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[11]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[12]).Visibility = Visibility.Collapsed;
                }
            }
            else
            {
                var mainElements = e.GetClickedElements<XamTreeGrid>();
                if (mainElements.Count > 0)
                {
                    _clickedTree = mainElements[0];
                    // task menu items
                    ((XamMenuItem)contextMenuClusters.Items[0]).Visibility = Visibility.Visible;
                    ((XamMenuItem)contextMenuClusters.Items[1]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[2]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[3]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[4]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[5]).Visibility = Visibility.Collapsed;

                    // activity menu items
                    ((XamMenuItem)contextMenuClusters.Items[6]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[7]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[8]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[9]).Visibility = Visibility.Collapsed;

                    // cluster menu items
                    ((XamMenuItem)contextMenuClusters.Items[10]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[11]).Visibility = Visibility.Collapsed;
                    ((XamMenuItem)contextMenuClusters.Items[12]).Visibility = Visibility.Collapsed;
                }
            }
        }
    }
}
