﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using XamTreeProblem.Annotations;

namespace XamTreeProblem
{
    public class VM : INotifyPropertyChanged
    {
        public VM()
        {
            Clusters = new ObservableCollection<Cluster>();

            Clusters.Add(new Cluster() {Name = "Cluster1"});
            Clusters.Add(new Cluster() {Name = "Cluster2"});
            Clusters.Add(new Cluster() {Name = "Cluster3"});
            Clusters.Add(new Cluster() {Name = "Cluster4"});

            Clusters[0].Activities.Add(new Activity() {Name="Activity1"});
            Clusters[0].Activities.Add(new Activity() {Name="Activity2"});
            Clusters[0].Activities.Add(new Activity() {Name="Activity3"});
            Clusters[0].Activities.Add(new Activity() {Name="Activity4"});

            Clusters[1].Activities.Add(new Activity() { Name = "Activity5" });
            Clusters[1].Activities.Add(new Activity() { Name = "Activity6" });
            Clusters[1].Activities.Add(new Activity() { Name = "Activity7" });
            Clusters[1].Activities.Add(new Activity() { Name = "Activity8" });

            Clusters[2].Activities.Add(new Activity() { Name = "Activity9" });
            Clusters[2].Activities.Add(new Activity() { Name = "Activity10" });
            Clusters[2].Activities.Add(new Activity() { Name = "Activity11" });
            Clusters[2].Activities.Add(new Activity() { Name = "Activity12" });

            Clusters[3].Activities.Add(new Activity() { Name = "Activity13" });
            Clusters[3].Activities.Add(new Activity() { Name = "Activity14" });
            Clusters[3].Activities.Add(new Activity() { Name = "Activity15" });
            Clusters[3].Activities.Add(new Activity() { Name = "Activity16" });

            Clusters[0].Activities[0].Tasks.Add(new Task(){Name="Task1"});
            Clusters[0].Activities[0].Tasks.Add(new Task(){Name="Task2"});
            Clusters[0].Activities[0].Tasks.Add(new Task(){Name="Task3"});

            Clusters[0].Activities[1].Tasks.Add(new Task() { Name = "Task4" });
            Clusters[0].Activities[1].Tasks.Add(new Task() { Name = "Task5" });
            Clusters[0].Activities[1].Tasks.Add(new Task() { Name = "Task6" });

            Clusters[0].Activities[2].Tasks.Add(new Task() { Name = "Task7" });
            Clusters[0].Activities[2].Tasks.Add(new Task() { Name = "Task8" });
            Clusters[0].Activities[2].Tasks.Add(new Task() { Name = "Task9" });

            Clusters[0].Activities[3].Tasks.Add(new Task() { Name = "Task10" });
            Clusters[0].Activities[3].Tasks.Add(new Task() { Name = "Task11" });
            Clusters[0].Activities[3].Tasks.Add(new Task() { Name = "Task12" });

            Clusters[1].Activities[0].Tasks.Add(new Task() { Name = "Task13" });
            Clusters[1].Activities[0].Tasks.Add(new Task() { Name = "Task14" });
            Clusters[1].Activities[0].Tasks.Add(new Task() { Name = "Task15" });

            Clusters[1].Activities[1].Tasks.Add(new Task() { Name = "Task16" });
            Clusters[1].Activities[1].Tasks.Add(new Task() { Name = "Task17" });
            Clusters[1].Activities[1].Tasks.Add(new Task() { Name = "Task18" });

            Clusters[1].Activities[2].Tasks.Add(new Task() { Name = "Task19" });
            Clusters[1].Activities[2].Tasks.Add(new Task() { Name = "Task20" });
            Clusters[1].Activities[2].Tasks.Add(new Task() { Name = "Task21" });

            Clusters[1].Activities[3].Tasks.Add(new Task() { Name = "Task22" });
            Clusters[1].Activities[3].Tasks.Add(new Task() { Name = "Task23" });
            Clusters[1].Activities[3].Tasks.Add(new Task() { Name = "Task24" });

            Clusters[2].Activities[0].Tasks.Add(new Task() { Name = "Task25" });
            Clusters[2].Activities[0].Tasks.Add(new Task() { Name = "Task26" });
            Clusters[2].Activities[0].Tasks.Add(new Task() { Name = "Task27" });

            Clusters[2].Activities[1].Tasks.Add(new Task() { Name = "Task28" });
            Clusters[2].Activities[1].Tasks.Add(new Task() { Name = "Task29" });
            Clusters[2].Activities[1].Tasks.Add(new Task() { Name = "Task30" });

            Clusters[2].Activities[2].Tasks.Add(new Task() { Name = "Task31" });
            Clusters[2].Activities[2].Tasks.Add(new Task() { Name = "Task32" });
            Clusters[2].Activities[2].Tasks.Add(new Task() { Name = "Task33" });

            Clusters[2].Activities[3].Tasks.Add(new Task() { Name = "Task34" });
            Clusters[2].Activities[3].Tasks.Add(new Task() { Name = "Task35" });
            Clusters[2].Activities[3].Tasks.Add(new Task() { Name = "Task36" });

            Clusters[3].Activities[0].Tasks.Add(new Task() { Name = "Task37" });
            Clusters[3].Activities[0].Tasks.Add(new Task() { Name = "Task38" });
            Clusters[3].Activities[0].Tasks.Add(new Task() { Name = "Task39" });

            Clusters[3].Activities[1].Tasks.Add(new Task() { Name = "Task40" });
            Clusters[3].Activities[1].Tasks.Add(new Task() { Name = "Task41" });
            Clusters[3].Activities[1].Tasks.Add(new Task() { Name = "Task42" });

            Clusters[3].Activities[2].Tasks.Add(new Task() { Name = "Task43" });
            Clusters[3].Activities[2].Tasks.Add(new Task() { Name = "Task44" });
            Clusters[3].Activities[2].Tasks.Add(new Task() { Name = "Task45" });

            Clusters[3].Activities[3].Tasks.Add(new Task() { Name = "Task46" });
            Clusters[3].Activities[3].Tasks.Add(new Task() { Name = "Task47" });
            Clusters[3].Activities[3].Tasks.Add(new Task() { Name = "Task48" });

        }

        private ObservableCollection<Cluster> _clusters;

        public ObservableCollection<Cluster> Clusters
        {
            get { return _clusters; }
            set { _clusters = value; OnPropertyChanged("Clusters"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
